/*
	       ,   :

	1.	     3 :
			DS (Data Segment,         );
			CS (Code Segment,      );
			IP (Instruction Pointer,     CS).
		         .
	2.	    :
			)    DS = 0, CS = 32, IP = 0;
			)    2000   (..   CS:IP     );
			)          0.
	3.	      :
			)           ,
			) 2  3 ,   /   ,    /  .
		    ,  2  3  -      ( CS).
	4.	  ,       ,
		     16  (4   4 ):
			) 1  -  ;
			)  3  -  (    -     ).
		    1-     ( CS)   0,
		  2-  - 16, 3-  - 32, 4-  - 48  ..
		      (   JMP),   IP   16.
	5.	   , :
			)   STOP
      b)     (  )


	      ( 4,   = 3)   
	    (   ):
		  MOV 0 3
		  MOV	1 4
		  MUL	1 1 2
		  MUL 0 2 3
		  PRT 3

	     1  10 ( <= b):
		  MOV 0 1      # 1 -  ,       
		  MOV 1 1      #      
		  MOV 2 11     #   + 1
		  PRT 1        #   
		  ADD 1 0 1    #    1 (  0)
		  CMP 1 2 3    #      ( 1,     )
		  JMP 3 4 -12  #  0 -   STOP ( ),
		               #   4  , ..  4-  PRN
      STP          #  

	   :
		  )           ,    
		  )      , ,      "input.txt"
	       (,     ).
*/

#include <cctype>
#include <cstdint>
//#include <stdint.h>
#include <fstream>
#include <iostream>
#include <string>
#include <algorithm>

using namespace std;


const string
	DEFAULT_FILENAME = "input.txt";


string extract_filename(const string &path) {
#if MSDOS || __OS2__ || __NT__ || _WIN32 || WIN32 || _WIN64 || WIN64
	const char FILE_SEPARATOR = '\\';
#else
	const char FILE_SEPARATOR = '/';
#endif
	return path.substr(path.find_last_of(FILE_SEPARATOR) + 1);
}


string upper(const string &s) {
	//return s;
	string result;
	for (unsigned int i = 0; i < s.size(); i++)
		result += toupper(s[i]);
	return result;
}


const int
	MEM_SIZE = 2000,
	CMD_SIZE = 4,
	START_DS = 0,
	START_CS = 1000,
	START_IP = 0;

typedef
	enum {
		UNKNOWN = 0,
		MOV = 1,
		ADD = 2,
		SUB = 3,
		MUL = 4,
		DIV = 5,
    MOD = 6,
		CMP = 7,
		JMP = 8,
		PRT = 9,
    INP = 10,
    ST = 11,
    LD = 12,
    STP = 13,
	} command_code_t;

typedef
	struct {
		string name;
		int operands_count;
	} command_desc_t;
const
	command_desc_t commands_desc[STP + 1] = {
		{ "", 0 },
		{ "MOV", 2 },
		{ "ADD", 3 },
		{ "SUB", 3 },
		{ "MUL", 3 },
		{ "DIV", 3 },
    { "MOD", 3 },
		{ "CMP", 3 },
		{ "JMP", 3 },
		{ "PRT", 1 },
    { "INP", 1 },
    { "ST", 2 },
    { "LD", 2 },
    { "STP", 0 },
	};

typedef int32_t command_t[CMD_SIZE];



typedef struct {
	int DS, CS, IP;
	int32_t mem[MEM_SIZE];

	void load(istream &in) {
		DS = START_DS;
		CS = START_CS;
		IP = START_IP;
		fill(mem, mem + MEM_SIZE, 0);

		int cmd_index = 0;
		while (!in.eof()) {
			string str;
			in >> str;
			str = upper(str);
			
			command_t &cmd = (reinterpret_cast<command_t *>(reinterpret_cast<int32_t *>(&mem) + CS))[cmd_index];
			for (unsigned int i = 0; i < sizeof(commands_desc); i++)
				if (str == commands_desc[i].name) {
					if (i == UNKNOWN)
						return;
					if (CS + cmd_index * sizeof(command_t) >= MEM_SIZE) {
						cerr << "Too long program!" << endl;
						exit(2);
					}
					cmd[0] = i;
					break;
				}
			if (cmd[0] == static_cast<int32_t>(UNKNOWN)) {
				cerr << "Unknown command: " << str << "!" << endl;
				exit(2);
			}
			for (int i = 1; i <= commands_desc[cmd[0]].operands_count; i++) {
				in >> str;
				cmd[i] = stoi(str);
			}

			cmd_index++;
		}
	}


	void run() {
		while (true) {
			command_t &cmd = (reinterpret_cast<command_t *>(reinterpret_cast<int32_t *>(&mem) + CS + IP))[0];
			IP += 4;

			switch (cmd[0]) {
				case MOV:
					mem[DS + cmd[1]] = cmd[2];
					break;
				case ADD:
					mem[DS + cmd[3]] = mem[DS + cmd[1]] + mem[DS + cmd[2]];
					break;
				case SUB:
					mem[DS + cmd[3]] = mem[DS + cmd[1]] - mem[DS + cmd[2]];
					break;
				case MUL:
					mem[DS + cmd[3]] = mem[DS + cmd[1]] * mem[DS + cmd[2]];
					break;
				case DIV:
					mem[DS + cmd[3]] = mem[DS + cmd[1]] / mem[DS + cmd[2]];
					break;
        case MOD:
					mem[DS + cmd[3]] = mem[DS + cmd[1]] % mem[DS + cmd[2]];
					break;
				case CMP:
					mem[DS + cmd[3]] = mem[DS + cmd[1]] > mem[DS + cmd[2]]
					                       ? 1
					                       : mem[DS + cmd[1]] < mem[DS + cmd[2]]
					                             ? -1
                                                 : 0;
					break;
				case JMP:
					IP = IP + cmd[mem[DS + cmd[1]] > 0 ? 2 : 3] - 4;
					break;
				case PRT:
					cout << static_cast<int>(mem[DS + cmd[1]]) << endl;
					break;
        case INP:
          cout << "input: ";
					cin >> static_cast<int>(mem[DS + cmd[1]]);
					break;
        case ST:
          mem[static_cast<int>(mem[DS + cmd[1]])] = mem[DS + cmd[2]];
          break;
        case LD:
          mem[DS + cmd[2]] = mem[static_cast<int>(mem[DS + cmd[1]])];
          break;
        case STP:
          return;
				
				default:
					return;
			}

			if (CS + IP > MEM_SIZE - sizeof(command_t))
				return;
		}
	}
} Emulator;



int main(int argc, char* argv[])
{
	string filename = DEFAULT_FILENAME;
	if (argc > 1)
		filename = argv[1];

	if (filename == "--help") {
		cout <<
			"Usage: " << endl <<
			"  " << extract_filename(argv[0]) << " [program_filename]" << endl <<
			"  (if program_filename is not specified, default program_filename is \"input.txt\")" << endl;
		exit(0);
	}

	Emulator em;

	ifstream in(filename.c_str());
	if (!in.good()) {
		cerr << "File " << filename << " not found!" << endl;
		exit(1);
	}

	em.load(in);
	in.close();

	em.run();

  string s;
  getline(cin, s);

	return 0;
}
